package org.linotte.frame.cahier.timbre.ui;

import java.awt.Graphics2D;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

import org.linotte.frame.cahier.timbre.entite.Timbre;
import org.linotte.frame.cahier.timbre.outils.Historique;
import org.linotte.frame.cahier.timbre.ui.i.PlancheUI;

public class Planche implements PlancheUI {

	public Historique historique = new Historique(this); // L'historique est associé à la planche

	public Graphics2D graphics;

	public List<Timbre> timbres = new CopyOnWriteArrayList<Timbre>();

	// Position de l'objet glissé :
	public int delta_x = 0, delta_y = 0;
	// Centre graphique de la planche
	public int centre_x = 0, centre_y = 0;

	public boolean afficheAide = false;
	
	// Compteur pour la numérotation des acteurs 
	private Integer compteur = 0;

	public int compteurSuivant() {
		synchronized (compteur) {
			compteur++;
			return compteur;
		}

	}

	public void resteCompteur() {
		compteur = 0;
	}

}
