package org.linotte.frame.navinotte.protocole;

import java.io.File;

import javax.swing.SwingUtilities;

import org.linotte.frame.Atelier;
import org.linotte.frame.moteur.FrameProcess;
import org.linotte.frame.navinotte.NavinotteJavaFX;
import org.linotte.frame.navinotte.protocole.i.Protocole;
import org.linotte.moteur.outils.Ressources;

public class Lire implements Protocole {

	public final static String PROTOCOLE = "lire://";

	private Atelier atelier;

	public Lire(Atelier atelier) {
		this.atelier = atelier;

	}

	@Override
	public boolean can(String s) {
		return s.toLowerCase().startsWith(PROTOCOLE);
	}

	@Override
	public void handle(final String url) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {

				try {
					File p = new File(Ressources.getExemples(Atelier.linotte.getLangage()), url.substring(PROTOCOLE.length()));
					if (p.exists()) {
						NavinotteJavaFX.cacher();
						atelier.ouvrirLivre(new File(p.getAbsolutePath()));
						try {
							FrameProcess.stopProcess();
						} catch (Exception e) {
						}
						Thread.sleep(1000);
						atelier.getCahierCourant().processStyle.setStopLecture();
						FrameProcess.go(new StringBuilder(atelier.getCahierCourant().retourneTexteCahier() + "\n"), Atelier.linotte, atelier, false, -1);
					}

				} catch (Exception e1) {
					e1.printStackTrace();
				} finally {
				}
			}
		});
	}
}
