package org.linotte.greffons.impl.swing;

import java.awt.Component;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JOptionPane;

import org.linotte.greffons.externe.Composant;

/**
 * 
 * @author R.M
 * 
 */
public class Popup extends ComposantDeplacable {

	private Map<String, ImageIcon> cacheImage = new HashMap<String, ImageIcon>();

	private JOptionPane pane;

	@Override
	public void initialisation() throws GreffonException {
		pane = new JOptionPane();
	}

	@Override
	public void ajouterComposant(Composant composant) throws GreffonException {
	}

	@Override
	public JComponent getJComponent() throws GreffonException {
		return pane;
	}

	@Override
	public void destruction() throws GreffonException {
		pane = null;
	}

	@Override
	public boolean enregistrerPourDestruction() {
		return true;
	}

	@Slot
	public boolean message(String question) throws GreffonException {
		JOptionPane.showMessageDialog(retournePere(), question, null, JOptionPane.INFORMATION_MESSAGE);
		return true;
	}

	@Slot(nom = "messageeticône")
	public boolean messageeticone(String question, String icone) throws GreffonException {
		JOptionPane.showMessageDialog(retournePere(), question, null, JOptionPane.INFORMATION_MESSAGE, chargerImage(icone));
		return true;
	}

	@Slot
	public String question(String question, List<String> valeurs) throws GreffonException {
		Object[] options = valeurs.toArray();
		int n = JOptionPane.showOptionDialog(retournePere(), question, null, JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, options,
				options[0]);
		if (n >= 0) {
			return (String) options[n];
		}
		return "";
	}

	@Slot(nom = "questioneticône")
	public String questioneticone(String question, List<String> valeurs, String icone) throws GreffonException {
		Object[] options = valeurs.toArray();
		int n = JOptionPane.showOptionDialog(retournePere(), question, null, JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE,
				chargerImage(icone), options, options[0]);
		if (n >= 0) {
			return (String) options[n];
		}
		return "";
	}

	/**
	* @return
	* @throws GreffonException
	*/
	private Component retournePere() throws GreffonException {
		ComposantSwing pere = (ComposantSwing) getParent();
		Component awt = null;
		if (pere != null) {
			awt = pere.getJComponent();
		}
		return awt;
	}

	/**
	 * @param hauteur
	 * @param largeur
	 * @param source
	 */
	private ImageIcon chargerImage(String source) {
		source = getRessourceManager().analyserChemin(source);
		ImageIcon ii = cacheImage.get(source);
		if (ii == null)
			try {
				BufferedImage img = ImageIO.read(new File(source));
				if (img != null) {
					ii = new ImageIcon(img);
					cacheImage.put(source, ii);
				}
			} catch (IOException e1) {
			}
		return ii;
	}
}
